/*  This optional script allows openning images using drag&drop.
 *  To use it call
 *    initDnD(canvas,on_drop_func(image,filename,file_type) {
 *        // ... do something with the dropped image
 *    });
 */
(function() {
    var initedTargets = [];

    window.initDnD = function(canvas,loader) {

	function initTarget(target) {
	    target.addEventListener('drop', function(event) {
		try {
			if ('files' in event.dataTransfer) { // local files
			    for(var i=0; i < event.dataTransfer.files.length; i++) {
				var file = event.dataTransfer.files[i];
				if (file.type.match('image.*')) { // only process image files
				    var reader = new FileReader();
				    reader.onload = function(evt) {
					var image = new Image();
					image.onload = function() { loader(image,file.name,file.type); };
					image.src = evt.target.result;
				    };
				    reader.readAsDataURL(file);
				}
			    }
			}
		}
		catch (e) {}
		event.preventDefault();
	    });
	    function cancelEvent(event) { event.preventDefault(); }
	    target.addEventListener('dragover',cancelEvent);
	    target.addEventListener('dragenter',cancelEvent);
	}

	if (initedTargets.indexOf(canvas) < 0) {
	    initTarget(canvas);
	    initedTargets.push(canvas);
	}
    }
})();
